#include <iostream>
#include <math.h>
using namespace std;

#include "cga.h"

Bivector::Bivector()
{
	a = 0.0;
	b = 0.0;
	c = 0.0;
	d = 0.0;
}
Bivector::Bivector(double s,double e1,double e2,double e12)
{
	a = s;
	b = e1;
	c = e2;
	d = e12;
}
Bivector::~Bivector(){ }

void Bivector::setE(int e,double value)
{
	if(e == 0)
		a = value;
	if(e == 1)
		b = value;
	if(e == 2)
		c = value;
	if(e == 12)
		d = value;

}
double Bivector::getE(int e)
{
	if(e == 0)
		return a;
	if(e == 1)
		return b;
	if(e == 2)
		return c;
	if(e == 12)
		return d;
	else
		return -1;

}
Bivector Bivector::operator*(Bivector bv)
{
	Bivector bv_c;
	double a2 = bv.getE(0);
	double b2 = bv.getE(1);
	double c2 = bv.getE(2);
	double d2 = bv.getE(12);

	bv_c.setE(0 ,((a*a2) + (b*b2) + (c*c2) + (d*d2)));
	bv_c.setE(1 ,((a*b2) + (b*a2) - (c*d2) + (d*d2)));
	bv_c.setE(2 ,((c*a2) + (d*b2) + (a*c2) - (b*d2)));
	bv_c.setE(12,((a*a2) - (c*b2) + (b*c2) + (a*a2)));

	return bv_c;
}
void Bivector::print(void)
{
	cout <<a<<" "<<b<< "*e1"<<" "<<c<< "*e2"<<" " <<d<< "*e12" <<  endl;
}


Multivector::Multivector()
{
	a = 0.0;
	b = 0.0;
	c = 0.0;
	d = 0.0;
	e = 0.0;
	f = 0.0;
	g = 0.0;
	h = 0.0;

}
Multivector::Multivector(double s,double e1,double e2,double e3,double e12,double e13,double e23,double e123)
{
	a = s;
	b = e1;
	c = e2;
	d = e3;
	e = e12;
	f = e13;
	g = e23;
	h = e123;
}
Multivector::~Multivector(){ }

void Multivector::setE(int x,double value)
{
	if(x == 0)
		a = value;
	if(x == 1)
		b = value;
	if(x == 2)
		c = value;
	if(x == 3)
		d = value;
	if(x == 12)
		e = value;
	if(x == 13)
		f = value;
	if(x == 23)
		g = value;
	if(x == 123)
		h = value;

}
double Multivector::getE(int x)
{
	if(x == 0)
		return a;
	if(x == 1)
		return b;
	if(x == 2)
		return c;
	if(x == 3)
		return d;
	if(x == 12)
		return e;
	if(x == 13)
		return f;
	if(x == 23)
		return g;
	if(x == 123)
		return h;

	return 0;
}
Multivector operator+(Multivector ain,Multivector bin)
{
	Multivector result (ain.getE(0) + bin.getE(0),
					ain.getE(1) + bin.getE(1),
					ain.getE(2) + bin.getE(2),
					ain.getE(3) + bin.getE(3),
					ain.getE(12) + bin.getE(12),
					ain.getE(13) + bin.getE(13),
					ain.getE(23) + bin.getE(23),
					ain.getE(123) + bin.getE(123));

	return result;
}
Multivector operator-(Multivector ain,Multivector bin)
{
	Multivector result (ain.getE(0) - bin.getE(0),
					ain.getE(1) - bin.getE(1),
					ain.getE(2) - bin.getE(2),
					ain.getE(3) - bin.getE(3),
					ain.getE(12) - bin.getE(12),
					ain.getE(13) - bin.getE(13),
					ain.getE(23) - bin.getE(23),
					ain.getE(123) - bin.getE(123));

	return result;
}
Multivector operator*(Multivector ain,double s)
{
	Multivector result (ain.getE(0) * s,
					ain.getE(1) * s,
					ain.getE(2) * s,
					ain.getE(3) * s,
					ain.getE(12) * s,
					ain.getE(13) * s,
					ain.getE(23) * s,
					ain.getE(123) * s);

	return result;
}
Multivector operator*(double s,Multivector ain)
{
	Multivector result (ain.getE(0) * s,
					ain.getE(1) * s,
					ain.getE(2) * s,
					ain.getE(3) * s,
					ain.getE(12) * s,
					ain.getE(13) * s,
					ain.getE(23) * s,
					ain.getE(123) * s);

	return result;
}
Multivector operator/(Multivector ain,double s)
{
	Multivector result (ain.getE(0) / s,
					ain.getE(1) / s,
					ain.getE(2) / s,
					ain.getE(3) / s,
					ain.getE(12) / s,
					ain.getE(13) / s,
					ain.getE(23) / s,
					ain.getE(123) / s);

	return result;
}
Multivector operator/(double s,Multivector ain)
{
	Multivector result (ain.getE(0) / s,
					ain.getE(1) / s,
					ain.getE(2) / s,
					ain.getE(3) / s,
					ain.getE(12) / s,
					ain.getE(13) / s,
					ain.getE(23) / s,
					ain.getE(123) / s);

	return result;
}
Multivector gp(Multivector ain,Multivector bin)
{
	Multivector result;

	double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);


	result.setE(0  ,((a1*a2) + (b1*b2) + (c1*c2) + (d1*d2) - (e1*e2) - (f1*f2) - (g1*g2) - (h1*h2)));
	result.setE(1  ,((a1*b2) + (b1*a2) - (c1*e2) - (d1*f2) + (e1*c2) + (f1*d2) - (g1*h2) - (h1*g2)));
	result.setE(2  ,((a1*c2) + (b1*e2) + (c1*a2) - (d1*g2) - (e1*b2) + (f1*h2) + (g1*d2) + (h1*f2)));
	result.setE(3  ,((a1*d2) + (b1*f2) + (c1*g2) + (d1*a2) - (e1*h2) - (f1*b2) - (g1*c2) - (h1*e2)));
	result.setE(12 ,((a1*e2) + (b1*c2) - (c1*b2) + (d1*h2) + (e1*a2) - (f1*g2) + (g1*f2) + (h1*d2)));
	result.setE(13 ,((a1*f2) + (b1*d2) - (c1*h2) - (d1*b2) + (e1*g2) + (f1*a2) - (g1*e2) - (h1*c2)));
	result.setE(23 ,((a1*g2) + (b1*h2) + (c1*d2) - (d1*c2) - (e1*f2) + (f1*e2) + (g1*a2) + (h1*b2)));
	result.setE(123,((a1*h2) + (b1*g2) - (c1*f2) + (d1*e2) + (e1*d2) - (f1*c2) + (g1*b2) + (h1*a2)));

	return result;
}
Multivector operator*(Multivector ain,Multivector bin)
{
	Multivector result;

	double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);


	result.setE(0  ,((a1*a2) + (b1*b2) + (c1*c2) + (d1*d2) - (e1*e2) - (f1*f2) - (g1*g2) - (h1*h2)));
	result.setE(1  ,((a1*b2) + (b1*a2) - (c1*e2) - (d1*f2) + (e1*c2) + (f1*d2) - (g1*h2) - (h1*g2)));
	result.setE(2  ,((a1*c2) + (b1*e2) + (c1*a2) - (d1*g2) - (e1*b2) + (f1*h2) + (g1*d2) + (h1*f2)));
	result.setE(3  ,((a1*d2) + (b1*f2) + (c1*g2) + (d1*a2) - (e1*h2) - (f1*b2) - (g1*c2) - (h1*e2)));
	result.setE(12 ,((a1*e2) + (b1*c2) - (c1*b2) + (d1*h2) + (e1*a2) - (f1*g2) + (g1*f2) + (h1*d2)));
	result.setE(13 ,((a1*f2) + (b1*d2) - (c1*h2) - (d1*b2) + (e1*g2) + (f1*a2) - (g1*e2) - (h1*c2)));
	result.setE(23 ,((a1*g2) + (b1*h2) + (c1*d2) - (d1*c2) - (e1*f2) + (f1*e2) + (g1*a2) + (h1*b2)));
	result.setE(123,((a1*h2) + (b1*g2) - (c1*f2) + (d1*e2) + (e1*d2) - (f1*c2) + (g1*b2) + (h1*a2)));

	return result;
}
Multivector ip(Multivector ain,Multivector bin)
{
	Multivector result;

	//double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	//double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);

	result.setE(0  ,((b1*b2) + (c1*c2) + (d1*d2) - (e1*e2) - (f1*f2) - (g1*g2) - (h1*h2)));
	result.setE(1  ,(-(c1*e2) - (d1*f2) + (e1*c2) + (f1*d2) - (g1*h2) - (h1*g2)));
	result.setE(2  ,((b1*e2) - (d1*g2) - (e1*b2) + (f1*h2) + (g1*d2) + (h1*f2)));
	result.setE(3  ,((b1*f2) + (c1*g2) - (e1*h2) - (f1*b2) - (g1*c2) - (h1*e2)));
	result.setE(12 ,((d1*h2) + (h1*d2)));
	result.setE(13 ,(-(c1*h2) - (h1*c2)));
	result.setE(23 ,((b1*h2) + (h1*b2)));
	result.setE(123,0);

	return result;
}
Multivector operator^(Multivector ain,Multivector bin)
{
	Multivector result;

	double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);

	result.setE(0  ,((a1*a2)));
	result.setE(1  ,((a1*b2) + (b1*a2)));
	result.setE(2  ,((a1*c2) + (c1*a2)));
	result.setE(3  ,((a1*d2) + (d1*a2)));
	result.setE(12 ,((a1*e2) + (b1*c2) - (c1*b2) + (e1*a2)));
	result.setE(13 ,((a1*f2) + (b1*d2) - (d1*b2) + (f1*a2)));
	result.setE(23 ,((a1*g2) + (c1*d2) - (d1*c2) + (g1*a2)));
	result.setE(123,((a1*h2) + (b1*g2) - (c1*f2) + (d1*e2) + (e1*d2) - (f1*c2) + (g1*b2) + (h1*a2)));

	return result;
}
Multivector op(Multivector ain,Multivector bin)
{
	Multivector result;

	double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);

	result.setE(0  ,((a1*a2)));
	result.setE(1  ,((a1*b2) + (b1*a2)));
	result.setE(2  ,((a1*c2) + (c1*a2)));
	result.setE(3  ,((a1*d2) + (d1*a2)));
	result.setE(12 ,((a1*e2) + (b1*c2) - (c1*b2) + (e1*a2)));
	result.setE(13 ,((a1*f2) + (b1*d2) - (d1*b2) + (f1*a2)));
	result.setE(23 ,((a1*g2) + (c1*d2) - (d1*c2) + (g1*a2)));
	result.setE(123,((a1*h2) + (b1*g2) - (c1*f2) + (d1*e2) + (e1*d2) - (f1*c2) + (g1*b2) + (h1*a2)));

	return result;
}
Multivector lcip(Multivector ain,Multivector bin)
{
	Multivector result;

	double a1 = ain.getE(0);
	double b1 = ain.getE(1);
	double c1 = ain.getE(2);
	double d1 = ain.getE(3);
	double e1 = ain.getE(12);
	double f1 = ain.getE(13);
	double g1 = ain.getE(23);
	double h1 = ain.getE(123);

	double a2 = bin.getE(0);
	double b2 = bin.getE(1);
	double c2 = bin.getE(2);
	double d2 = bin.getE(3);
	double e2 = bin.getE(12);
	double f2 = bin.getE(13);
	double g2 = bin.getE(23);
	double h2 = bin.getE(123);


	result.setE(0  ,(a1*a2) + (b1*b2) + (c1*c2) + (d1*d2) - (e1*e2) - (f1*f2) - (g1*g2) - (h1*h2));
	result.setE(1  ,(a1*b2) - (c1*e2) - (d1*f2) - (g1*h2));
	result.setE(2  ,(a1*c2) + (b1*e2) - (d1*g2) + (f1*h2));
	result.setE(3  ,(a1*d2) + (b1*f2) + (c1*g2) - (e1*h2));
	result.setE(12 ,(a1*e2) + (d1*h2));
	result.setE(13 ,(a1*f2) - (c1*h2));
	result.setE(23 ,(a1*g2) + (b1*h2));
	result.setE(123,(a1*h2));

	return result;
}
Multivector reverse(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(a,b,c,d,-e,-f,-g,-h);

	return result;
}
Multivector operator~(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(a,b,c,d,-e,-f,-g,-h);

	return result;
}
Multivector dual(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(h,g,-f,e,-d,c,-b,-a);

	return result;
}
Multivector conjugate(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(a,-b,-c,-d,-e,-f,-g,h);

	return result;
}
Multivector inverse(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	double demon = ((a*a)+(b*b)+(c*c)+(d*d)+(e*e)+(f*f)+(g*g)+(h*h));

	if(demon == 0)
		return ain;

	a /= demon;
	b = -b / demon;
	c = -c / demon;
	d = -d / demon;
	e = -e / demon;
	f = -f / demon;
	g = -g / demon;
	h /= demon;


	Multivector result(a,b,c,d,e,f,g,h);

	return result;
}
Multivector operator!(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	double demon = ((a*a)+(b*b)+(c*c)+(d*d)+(e*e)+(f*f)+(g*g)+(h*h));

	if(demon == 0)
		return ain;

	a /= demon;
	b = -b / demon;
	c = -c / demon;
	d = -d / demon;
	e = -e / demon;
	f = -f / demon;
	g = -g / demon;
	h /= demon;


	Multivector result(a,b,c,d,e,f,g,h);

	return result;
}
void Multivector::normalize(void)
{
	double demon = ((a*a)+(b*b)+(c*c)+(d*d)+(e*e)+(f*f)+(g*g)+(h*h));
	a /= demon;
	b /= demon;
	c /= demon;
	d /= demon;
	e /= demon;
	f /= demon;
	g /= demon;
	h /= demon;

}
Multivector neg(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(-a,-b,-c,-d,-e,-f,-g,-h);

	return result;
}
Multivector operator-(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	Multivector result(-a,-b,-c,-d,-e,-f,-g,-h);

	return result;
}
double mag(Multivector ain)
{
	double a = ain.getE(0);
	double b = ain.getE(1);
	double c = ain.getE(2);
	double d = ain.getE(3);
	double e = ain.getE(12);
	double f = ain.getE(13);
	double g = ain.getE(23);
	double h = ain.getE(123);

	return sqrt((a*a)+(b*b)+(c*c)+(d*d)+(e*e)+(f*f)+(g*g)+(h*h));

}
Multivector spinor(float angle,Multivector unit)
{
 	Multivector result(cos(0.5*angle),0,0,0,sin(0.5 * angle*unit.getE(12)),sin(0.5 *angle* unit.getE(13)),sin(0.5 *angle* unit.getE(23)),0);
	return result;
}
Multivector rotate(float w,Multivector unit,Multivector p)
{

	Multivector s = spinor(w,unit);
	Multivector r = inverse(s);
	Multivector v = gp(s,p);

	Multivector result = gp(v,r);

	return result;

}
Multivector translate(Multivector dist,Multivector trans,Multivector point)
{

	Multivector c = trans^point;
	Multivector dc = dual(c);
	Multivector result = dist + dc;

	return result;

}
Multivector operator/(Multivector ain,Multivector bin)
{
    Multivector ibin = inverse(bin);
    Multivector result = gp(ain,ibin);
    return result;
}
void Multivector::print(void)
{
	cout <<a<<" "<<b<< "*e1"<<" "<<c<< "*e2"<<" " <<d<< "*e3" <<" " <<e<< "*e12" <<" " <<f<< "*e13" <<" " <<g<< "*e23" <<" " <<h<< "*e123" << endl;
}
