#include <iostream>

#ifdef WIN32
#include <GL/openglut.h>
#else
#include <GL/glut.h>
#endif /* WIN32 */

#include "procedure.h"


float zoom = 15.0f;
float rotx = 0;
float roty = 0.001f;
float tx = 0;
float ty = 0;
int lastx=0;
int lasty=0;
int grid = 0;
int ga = 1;
float rq = 0.0;
unsigned char Buttons[3] = {0};
int frame=0;
int itime;
int timebase=0;
char s[30];
void Init() 
{
    GLfloat mat_specular[] = {1.0,100.0,100.0,1.0};
    GLfloat mat_shininess[] = { 50.0 };
    GLfloat light_position [] = {10.0,10.0,10.0,0.0};
    GLfloat white_light[] = { 1.0,1.0,1.0,1.0};
    glClearColor( 0.0, 0.0, 0.0, 0.0);
    glShadeModel(GL_SMOOTH);   
    
    glMaterialfv(GL_FRONT, GL_SPECULAR,mat_specular);
    glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);   
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, white_light);
    glLightfv(GL_LIGHT0, GL_SPECULAR, white_light);

    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_DEPTH_TEST);

}
void idle()
{
	glutPostRedisplay();
}
void display()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glClearColor(0.5f,0.5f,0.5f,0.0f); 
	glLoadIdentity();

	glTranslatef(0,0,-zoom);
	glTranslatef(tx,ty,0);
	glRotatef(rotx,1,0,0);
	glRotatef(roty,0,1,0);	

	// draw grid
	glDisable(GL_LIGHTING);
	if(grid)
		drawGrid(10);
	glEnable(GL_LIGHTING);
	if(ga)
	{
    	frame++;
        itime=glutGet(GLUT_ELAPSED_TIME);
        rq = 0.01 * frame/100;
    	list(rq);

    }		
	glutSwapBuffers();
}
void reshape(int w, int h)
{
	// prevent divide by 0 error when minimised
	if(w==0) 
		h = 1;

	glViewport(0,0,w,h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45,(float)w/h,0.1,100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}
void Motion(int x,int y)
{
	int diffx = x-lastx;
	int diffy = y-lasty;
	lastx = x;
	lasty = y;

	if( Buttons[2]  )
	{
		zoom -= (float) 0.05f * diffx;
	}
	else if( Buttons[0] )
	{
		rotx += (float) 0.5f * diffy;
		roty += (float) 0.5f * diffx;		
	}
	else if( Buttons[1] )
	{
		tx += (float) 0.05f * diffx;
		ty -= (float) 0.05f * diffy;
	}
	glutPostRedisplay();
}
void Mouse(int b,int s,int x,int y)
{
	lastx=x;
	lasty=y;
	switch(b)
	{
	case GLUT_LEFT_BUTTON:
		Buttons[0] = ((GLUT_DOWN==s)?1:0);
		break;
	case GLUT_MIDDLE_BUTTON:
		Buttons[1] = ((GLUT_DOWN==s)?1:0);
		break;
	case GLUT_RIGHT_BUTTON:
		Buttons[2] = ((GLUT_DOWN==s)?1:0);
		break;
	default:
		break;		
	}
	glutPostRedisplay();
}
void processNormalKeys(unsigned char key, int x, int y) 
{
	if (key == 103 || key == 71) 
		grid =(grid == 1) ? 0: 1; 
	if (key == 118 || key == 86) 
		ga =(ga == 1) ? 0: 1; 
	if (key == 27 || key == 113) 
		exit(0);
	if (key == 114 || key == 82)
    	rq += 0.05f;
	glutPostRedisplay();
}
int main(int argc,char** argv)
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(100,100);
	glutCreateWindow("CGA");


	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(Mouse);
	glutMotionFunc(Motion);

	glutKeyboardFunc(processNormalKeys);
	//glutSpecialFunc(processSpecialKeys);	

	Init();
    glutIdleFunc(idle);
	glutMainLoop();
}
